package events;

import board.IBoard;

/**
 * A condition for winning the game.
 */
public interface IWinCondition {
    /**
     * Checks if someone has won according to the custom conditions.
     *
     * @param x     The x-coordinate of the last placed element
     * @param y     The y-coordinate of the last placed element
     * @param board The board to check
     * @return      True if someone has won
     */
    boolean hasWon(int x, int y, IBoard board);
}
